<?php
/**
 * @package	HikaShop for Joomla!
 * @version	2.2.2
 * @author	hikashop.com
 * @copyright	(C) 2010-2013 HIKARI SOFTWARE. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
 
defined('_JEXEC') or die('Restricted access');
?><?php
class plgHikashoppaymentEuPlatesc extends hikashopPaymentPlugin
{
	var $accepted_currencies = array('USD','EUR','RON');
	var $multiple = true;
	var $name = 'euplatesc';
	var $pluginConfig = array(
		'merchant_id' => array('MID', 'input'),
		'merchant_key' => array('KEY', 'input')
	);
	
	function onAfterOrderConfirm(&$order,&$methods,$method_id) {
		parent::onAfterOrderConfirm($order,$methods,$method_id);
		
		$dataAll = array(
			'amount'      => round($order->cart->full_total->prices[0]->price_value_with_tax,(int)$this->currency->currency_locale['int_frac_digits']),
			'curr'        => $this->currency->currency_code,
			'invoice_id'  => $order->order_id,
			'order_desc'  => $order->order_number,
			'merch_id'    => $this->payment_params->merchant_id,
			'timestamp'   => gmdate("YmdHis"),
 			'nonce'       => md5(microtime() . mt_rand()),
		); 
  
		$dataAll['fp_hash'] = strtoupper($this->euplatesc_mac($dataAll,$this->payment_params->merchant_key));
		
		$dataAll['fname'] = $order->cart->billing_address->address_firstname;
		$dataAll['lname'] = $order->cart->billing_address->address_lastname;
		$dataAll['email'] = $this->user->user_email;

		$dataAll['silent'] = HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=checkout&task=notify&notif_payment=euplatesc&tmpl=component&lang='.$this->locale.$this->url_itemid;
		$dataAll['ExtraData[successurl]'] = HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=checkout&task=after_end&order_id='.$order->order_id.$this->url_itemid;	
		
		$this->vars = array(
			'SendEMail' => 0,
			'AllowGiftAid' => 0,
			'ApplyAVSCV2' => 0,
			'Apply3DSecure' => 0,
		);

		$this->url = 'https://secure.euplatesc.ro/tdsprocess/tranzactd.php?'.http_build_query($dataAll);

		return $this->showPage('end');
	}
	
	function debug($text){
		file_put_contents("hika.txt",$text."\n\n",FILE_APPEND);
	}
	
	function onPaymentNotification(&$statuses){
		
		
		
		if(!isset($_POST['invoice_id'])){
			echo "Invalid request";
			$this->debug("Invalid request");
			return false;
		}
		
		$order_id = (int)$_POST['invoice_id'];
		$dbOrder = $this->getOrder($order_id);
		if(empty($dbOrder)){
			echo "Could not load any order for your notification";
			$this->debug("ould not load any order for your notification");
			return false;
		}
		$this->loadPaymentParams($dbOrder);
		if(empty($this->payment_params))
			return false;
		$this->loadOrderData($dbOrder);
		$order_status = $dbOrder->order_status;

		
		$zcrsp =  array (
			'amount'     => addslashes(trim(@$_POST['amount'])),
			'curr'       => addslashes(trim(@$_POST['curr'])), 
			'invoice_id' => addslashes(trim(@$_POST['invoice_id'])),
			'ep_id'      => addslashes(trim(@$_POST['ep_id'])),
			'merch_id'   => addslashes(trim(@$_POST['merch_id'])),
			'action'     => addslashes(trim(@$_POST['action'])), 
			'message'    => addslashes(trim(@$_POST['message'])),
			'approval'   => addslashes(trim(@$_POST['approval'])),
			'timestamp'  => addslashes(trim(@$_POST['timestamp'])),
			'nonce'      => addslashes(trim(@$_POST['nonce'])),
		);
			 
		$zcrsp['fp_hash'] = strtoupper($this->euplatesc_mac($zcrsp, $this->payment_params->merchant_key));
		$fp_hash=addslashes(trim(@$_POST['fp_hash']));
		
		if($zcrsp['fp_hash']!=$fp_hash)	{
			
			$history = new stdClass();
			$history->notified = 0;
			$history->reason = JText::_('PAYMENT_MD5_ERROR');
			$history->data = "Payment by EuPlatesc - Invalid MD5 - EuPlatesc transaction ID: " . $_POST['ep_id'];
			$this->modifyOrder($order_id, $this->payment_params->invalid_status, $history);

			return false;
			
		} else {
			
			if($_POST['action']==0){
				
				if($order_status=='pending')return false;
				
				$order_status='pending';
				
				$history->reason = JText::_('PAYMENT_ORDER_CONFIRMED');
				$history->notified=1;
				$history->data = "Payment by EuPlatesc - Transaction ID: ".$_POST['ep_id'];

				$mail_status = $statuses[$order_status];
				$email->subject = JText::sprintf('PAYMENT_NOTIFICATION_FOR_ORDER','EuPlatesc',$order_status,$dbOrder->order_number);
				$email->body = str_replace('<br/>',"\r\n",JText::sprintf('PAYMENT_NOTIFICATION_STATUS','EuPlatesc',$order_status)).' '.JText::sprintf('ORDER_STATUS_CHANGED',$mail_status)."\r\n\r\n".$order_text;

				$this->modifyOrder($order_id,$order_status,$history,$email);
				return true;
			}else{
				$order_status='cancelled';
				
				$history->reason = JText::_('PAYMENT_ORDER_CONFIRMED');
				$history->notified=1;
				$history->data = "Payment by EuPlatesc - Transaction ID: ".$_POST['ep_id'];
				$this->modifyOrder($order_id,$order_status,$history);
				return true;
			}
		}
	
		return false;
	
	}
	
	function getPaymentDefaultValues(&$element) {
		$element->payment_name='EuPlatesc';
		$element->payment_description='You can pay by credit card using this payment method';
		$element->payment_images='VISA,Maestro,MasterCard';
	}

	function hmacsha1($key,$data) {
		$blocksize = 64;
		$hashfunc  = 'md5';
		if(strlen($key) > $blocksize){
			$key = pack('H*', $hashfunc($key));
		}
		$key  = str_pad($key, $blocksize, chr(0x00));
		$ipad = str_repeat(chr(0x36), $blocksize);
		$opad = str_repeat(chr(0x5c), $blocksize);
		$hmac = pack('H*', $hashfunc(($key ^ $opad) . pack('H*', $hashfunc(($key ^ $ipad) . $data))));
		return bin2hex($hmac);
	}
	
	function euplatesc_mac($data, $key){
		$str = NULL;
		foreach($data as $d){
			if($d === NULL || strlen($d) == 0){
				$str .= '-';
			}else{
				$str .= strlen($d) . $d;
			}
		}
		$key = pack('H*', $key);
		return $this->hmacsha1($key, $str);
	}
}
